# Converts analects.txt into a flat array of verses and writes it to an.yaml.

an = File.open("analects.txt")
book = ''; title = ''; chapter = ''; verse = ''
bookno = ''; chapterno = ''; verseno = ''
versearray = Array.new
start_verse = false
count = 0

last_line = ''
#while ((line = an.gets) != nil)
while true
  if last_line != '' 
    line = last_line 
    last_line = ''
  else
    line = an.gets 
    if line == nil then break end
  end
  if line.chomp =~ /BOOK (.*?)\. (.*?)\./
    book = $1.strip
    title = $2.strip.capitalize
    next
  end
  if line =~ /\bCHAP(?:TER |\. )?(.*?)\. (.*)/
    chapter = $1.strip
    puts "Book #{book} Chapter #{chapter}"
    start_verse = true
    verse = $2.strip << ' '
    #next
  end
  while start_verse
    line = an.gets
    if line == nil then break end
    if line =~ /\bCHAP(?:TER |\. )?/ or line =~ /\bBOOK / or line =~ /^End of/
      puts "#{verse}" unless verse.strip == '' or verse == nil
      versearray.push("Book #{book}, Chapter #{chapter}: #{verse}")
      start_verse = false 
      verse = '' 
      last_line = line
      break 
    end
    verse.concat(line.strip << ' ')
    #verse.concat(line.chomp)
  end

  #if count > 500 then break end
  count += 1

end

#puts versearray.join("\n")

require 'yaml'
yaml_arr = versearray.to_yaml
File.open("analects.yaml", "w+") { |file| file.puts yaml_arr }
