require 'drb'

class BartAgentWrapper

  def initialize(callerObj = Object.new)
    @callerObj = callerObj
    DRb.start_service()
    @bot = DRbObject.new(nil, 'druby://localhost:9280')
  end

  def method_missing(input = '')
    input = input.to_s
    input.chomp!
    if input =~ /^\w+(?:bot|agent)/i and input !~ /^bart/i then return end
    if input =~ /^!/ then return end
    if input =~ /^@/ then return end
    if input =~ /^link\b/i then return end
    if input =~ /^lgp\b/i then return end
    if input =~ /^alice\b/i then return end
    if input =~ /^if\b/i then return end
    if input =~ /^calc\b/i then return end
    if input =~ /^logic\b/i then return end

    if input =~ /^find corefs[:, ]*/i then score += 3 end
    response = "I'm working on it..."
    #@callerObj.addResponse(["#{response}", score, "bartagent"])

    @callerObj.set_wait_for_agent("bartagent")
    response, score  = @bot.getResponse(input)
    @callerObj.unset_wait_for_agent("bartagent")
    if score == nil then score = 1 end
    if response.to_s =~ /Default response/ then score = 0 end
    if response.to_s =~ /Eep!/i then score = 0 end
    if response.to_s =~ /No corefs found/i then score = 1 end
    if input =~ /^bart(?:bot|agent)?[:, ]*/i then score += 4 end
    if response.to_s.strip == '' or response == nil then score = 0 end
    response = response.to_s.strip
    puts "BartBot: #{response} | #{score}" unless @callerObj.DEBUG == 0
    @callerObj.addPendingResponse(["#{response}", score, "bartagent"]) unless score < 2
    @callerObj.addResponse(["#{response}", score, "bartagent"])
  end
end
