require 'drb'

class LppAgent

  def initialize(callerObj = Object.new)
    @callerObj = callerObj
  end

  def method_missing(input = "")
    input = input.to_s
    input.chomp!
    score = 0
    if input =~ /is it (morning|evening|afternoon)+/i
      if Time.now.hour < 12 then response =  "Morning" end
      if Time.now.hour >= 12 and Time.now.hour <= 19 then response = "afternoon" end
      if Time.now.hour > 19 and Time.now.hour <= 24 then response =  "It's evening." end
      score = 5
    end
    if input =~ /which is (?:bigger|larger|smaller)+.*grape.*or.*grapefruit/i
      response = "A grape is smaller than a grapefruit."
      score = 5
    end
    if input =~ /which is (?:faster|slower)+.*train.*plane/i
      response = "A train is generally slower than a plane."
      score = 5
    end
    if input =~ /(.*) is older than (.*) and (.*) is older than (.*)\.*oldest/
      response =  "#{$1} is the oldest!"
      score = 5
    end
    if input =~ /(.*) is younger than (.*) and (.*) is younger than (.*)\.*oldest/
      response =  "I think #{$4} is the oldest!"
      score = 5
    end
    if input =~ /(.*) is younger than (.*) and (.*) is younger than (.*)\.*youngest/
      response =  "I think #{$1} is the youngest."
      score = 5
    end
    if input =~ /date.*Final Four/i or input =~ /Final Four.*date/i
      response = "The date the Final Four are announced is June 1 2009."
      score = 5
    end
    if input =~ /when.*competition.*start/i
      response = "The competition is scheduled to start at 10:00am on Sunday Sept 6, 2009."
      score = 5
    end
    if input =~ /how many.*rounds/i
      response = "There will be 7 rounds of 20 minutes each."
      score = 5
    end
    if input =~ /how long.*round/i
      response = "The rounds are 20 minutes long."
      score = 5
    end
    puts "Lpp: #{response} | #{score}" unless @callerObj.DEBUG == 0
    @callerObj.addResponse([response, score, "lppagent"])
  end

end
