require 'drb'

class MathetesAgent

  attr_accessor :MY_NAME

  def initialize(callerObj = Object.new)
    @callerObj = callerObj
    DRb.start_service()
    @mathetes = DRbObject.new(nil, 'druby://localhost:9030')
    @listening = true
    @MY_NAME = "(?i)(?:mathetes|mathetesagent|mathetesbot|math)"
  end

  def method_missing(input = '')
    input = input.to_s
    input.chomp!

    sleepwords = ["sleep", "stop listening", "ignore"]
    listenwords = ["listen", "wake up", "pay attention", "start listening"]
    if input =~ /^#{@MY_NAME}[:,! ]*.*?(#{sleepwords.join('|')})+/i
      #puts "1Mathetes input==#{input}"
      @listening = false
      response = "Mathetes is not listening to input."; score = 2
    elsif input =~ /^#{@MY_NAME}[:,!]* (#{listenwords.join('|')})+/i
      #puts "2Mathetes input==#{input}"
      @listening = true
      response = "Mathetes is now listening to input."; score = 2
    else
      #puts "3Mathetes input==#{input}; @listening=#{@listening}"
      if @listening then response = @mathetes.say(input) end
      score = rand(3) 
    end
    if response == nil or response == ""
      response = "Default response from Mathetes."; score = 0
    end
    if input =~ /^#{@MY_NAME}[:, ]*/i then score += 2 end
    puts "Mathetes: #{response} | #{score}" unless $DEBUG == 0
    @callerObj.addResponse(["#{response}", score, "mathetes"])
  end
end
