require 'drb'

class OppAgent

  def initialize(callerObj = Object.new)
    @callerObj = callerObj
    DRb.start_service()
    @oppbot = DRbObject.new(nil, 'druby://localhost:9120')
  end

  def method_missing(input = '')
    input = input.to_s
    input.chomp!
    if input =~ /^gagent/ then return end
    if input =~ /^\w+(?:bot|agent)/i and input !~ /^opp/ then return end
    if input =~ /^link\b/ then return end
    if input =~ /^lgp\b/ then return end
    if input =~ /^megahal\b/i then return end
    if input =~ /^alice\b/i then return end
    if input =~ /^calc\b/i then return end
    if input =~ /^porsi\b/i then return end
    response, score  = @oppbot.getResponse(input)
    if score == nil then score = 1 end
    if response.to_s =~ /Default response/ then score = 0 end
    if input =~ /^opp(?:bot|agent)?[:, ]*/i then score += 4 end
    if response.to_s.strip == '' or response == nil then score = 0 end
    response = response.to_s.strip
    if input =~ /opposite/ and response =~ / not / then score += 3 end
    if input =~ /opposite/ and input =~ / not / and response !~ / not / then score += 3 end
    puts "OppBot: #{response} | #{score}" unless @callerObj.DEBUG == 0
    @callerObj.addResponse(["#{response}", score, "oppagent"])
  end
end
