require 'drb'

class SumAgent

  def initialize(callerObj = Object.new)
    @callerObj = callerObj
    DRb.start_service()
    @sumbot = DRbObject.new(nil, 'druby://localhost:9110')
  end

  def method_missing(input = '')
    input = input.to_s
    input.chomp!
    response, score  = @sumbot.getResponse(input)
    if score == nil then score = 1 end
    if response.to_s =~ /Default response/ then score = 0 end
    if input =~ /^sum(?:bot|agent)?[:, ]*/i then score += 10 end
    if response.to_s.strip == '' or response == nil then score = 0 end
    response = response.to_s
    response.chomp!
    puts "SumBot: #{response} | #{score}" unless @callerObj.DEBUG == 0
    @callerObj.addResponse(["#{response}", score, "sumagent"])
  end
end
