require 'drb'

class SyllAgentWrapper

  def initialize(callerObj = Object.new)
    @callerObj = callerObj
    DRb.start_service()
    @bot = DRbObject.new(nil, 'druby://localhost:9180')
  end

  def method_missing(input = '')
    input = input.to_s
    input.chomp!
    if input =~ /^\w+(?:bot|agent)/i and input !~ /^syll/i then return end
    if input =~ /^link/i then return end
    if input =~ /^calc/i then return end
    if input =~ /^alice/i then return end
    response, score  = @bot.getResponse(input)
    if score == nil then score = 1 end
    #if response.to_s =~ /Default response/ then score = 0 end
    if input =~ /^syll(?:bot|agent)?[:, ]*/i then score += 4 end
    if response.to_s.strip == '' or response == nil then score = 0 end
    response = response.to_s.strip
    puts "SyllBot: #{response} | #{score}" unless @callerObj.DEBUG == 0
    @callerObj.addResponse(["#{response}", score, "syllagent"])
  end
end
