require 'drb'

class WAAgentWrapper

  def initialize(callerObj = Object.new)
    @callerObj = callerObj
    DRb.start_service()
    @bot = DRbObject.new(nil, 'druby://localhost:9300')
  end

  def method_missing(input = '')
    input = input.to_s
    input.chomp!
    if input =~ /^\w+(?:bot|agent)/i and input !~ /^wa/i then return end
    if input =~ /^!/ then return end
    if input =~ /^@/ then return end
    if input =~ /^link\b/i then return end
    if input =~ /^lgp\b/i then return end
    if input =~ /^alice\b/i then return end
    if input =~ /^if\b/i then return end
    if input =~ /^calc\b/i then return end
    if input =~ /^logic\b/i then return end
    if input =~ /^dp\b/i then return end
    if input =~ /^ak\b/i then return end
    if input =~ /^an\b/i then return end
    if input =~ /\.?wa(?:bot|agent)?/
      puts "[waagentwrapper] calling @callerObj.setResponse"
      @callerObj.setResponse("Please wait for waagent to respond...", 5)
    end
    @callerObj.set_wait_for_agent("waagent")
    response, score  = @bot.getResponse(input)
    @callerObj.unset_wait_for_agent("waagent")
    if score == nil then score = 1 end
    if response.to_s =~ /Default response/ then score = 0 end
    if response.to_s =~ /Eep!/i then score = 0 end
    if input =~ /^wa(?:bot|agent)?[:, ]*/i then score += 4 end
    if response.to_s.strip == '' or response == nil then score = 0 end
    if response =~ /Couldn't grab results from/i then score = 0 end
    response = response.to_s.strip
    puts "WaBot: #{response} | #{score}" unless @callerObj.DEBUG == 0
    #@callerObj.addPendingResponse(["#{response}", score, "waagent"]) unless score < 1
    @callerObj.setResponse(["#{response}", score, "waagent"]) unless score < 1
    #@callerObj.addResponse(["#{response}", score, "waagent"])
  end
end
