require 'test/unit'
require 'hunters/hunters'
require 'fileutils'

class TestMyAgent < Test::Unit::TestCase

  def setup
    Dir.chdir('hunters')
    @hunters = Hunters.new
  end 

  def test_run_hunters
    actual = @hunters.getstr
    assert_match(/x dimension/m, actual)
    @hunters.putstr("10")
    actual = @hunters.getstr
    assert_match(/y dimension/, actual)
    @hunters.putstr("10")
    assert_match(/number of hunters/m, @hunters.getstr)
    @hunters.putstr("10")
    assert_match(/food cells/, @hunters.getstr)
    @hunters.putstr("10")
    assert_match(/value of each food cell/, @hunters.getstr)
    @hunters.putstr("10")
    assert_match(/amount of food/, @hunters.getstr)
    @hunters.putstr("10")
    assert_match(/consume each round/, @hunters.getstr)
    @hunters.putstr("10")
    assert_match(/cost of attacking/, @hunters.getstr)
    @hunters.putstr("10")
    assert_match(/offset of attacking/, @hunters.getstr)
    @hunters.putstr("10")
    assert_match(/offset of sharing/, @hunters.getstr)
    @hunters.putstr("10")
    assert_match(/offset of hoarding/, @hunters.getstr)
    @hunters.putstr("10")
    assert_match(/vision range/, @hunters.getstr)
    @hunters.putstr("10")
    assert_match(/maximum power/, @hunters.getstr)
    @hunters.putstr("10")
    assert_match(/number of generations/, @hunters.getstr)
    @hunters.putstr("1")
    assert_match(/number of rounds/, @hunters.getstr)
    @hunters.putstr("1")
    assert_match(/sleep delay/, @hunters.getstr)
    @hunters.putstr("0")
    assert_match(/----------/, @hunters.getstr)
  end

  def teardown
    @hunters.kill_hunters
    Dir.chdir('..')
  end

end
