# Converts akaranga.txt into a flat array of verses and writes it to ak.yaml.

ak = File.open("akaranga.txt")
book = ''; lecture = ''; called = ''; lesson = ''; verse = ''
bookno = ''; lectureno = ''; lessonno = ''; verseno = ''
verses = false; nextline = ''; versearray = []
count = 0

def titlecase(s = '')
  arr = []
  #first = true
  s.split.map { |w|
    #if first then arr.push(w.downcase); first = false; next end
    if w =~ /\.$/ then w.chop! end
    arr.push(w.capitalize)
  }
  if arr[0] =~ /.?called.?/i then arr[0] = 'called' end
  if arr[0] !~ /called/i and arr.size > 0 then arr.insert(0,'called') end
  arr.join(' ') 
end

def convert(word = '', mode = '')
  case word
    when /First/i then return '1'
    when /Second/i then return '2'
    when /Third/i then return '3'
    when /Fourth/i then return '4'
    when /Fifth/i then return '5'
    when /Sixth/i then return '6'
    when /Seventh/i then return '7'
    when /Eighth/i then return '8'
    when /Ninth/i then return '9'
    when /Tenth/i then return '10'
    when /Eleventh/i then return '11'
    when /Twelfth/i then return '12'
    when /Thirteenth/i then return '13'
    when /Fourteenth/i then return '14'
    when /Fifteenth/i then return '15'
    when /Sixteenth/i then return '16'
    when /Seventeenth/i then return '17'
    when /Eighteenth/i then return '18' 
  end
end

while (line = ak.gets) != nil
  if line.chomp =~ /(.*) BOOK/
    book = $1.strip.capitalize
    if book =~ /First/ then bookno = 'I' end
    if book =~ /Second/ then bookno = 'II' end
    next
  end
  if line =~ /(.*) LECTURE[,\.](.*)/ or line =~ /(.*) LECTURE $/
    lecture = $1.strip.capitalize
    lectureno = convert(lecture)
    #called = titlecase($2.strip) unless $2 == nil
    #comma = ','; if called == nil or called == '' then comma = '' end
    #puts "#{book} Book #{lecture} Lecture#{comma} #{called}"
    next
  end
  if line =~ /(.*) LESSON/
    lesson = $1.strip.capitalize
    #puts "  #{lesson} Lesson"
    lessonno = convert(lesson)
    verses = true
    verse = ''
    next
  end
  if line =~ /(.*) \((\d+)\) (.*)/
    line = $1; verseno = $2; nextline = $3
    #puts "   #{line.strip}" unless not verses
    verse.concat(line.strip) unless not verses
    #puts verse
    versearray.push(verse << "  #{bookno}:#{lectureno}:#{lessonno}:#{verseno}")
    verse = ''
    next
  end
  if nextline != ''
    #puts "   #{nextline.concat(line.strip)}"
    verse.concat(nextline.concat(line.strip << ' '))
    nextline = ''
    next
  end
  if line =~ /(.*) \((\d+)\)/ 
    line = $1.to_s; verseno = $2
    #puts "  #{line.strip) unless not verses
    verse.concat(line.strip) unless not verses
    versearray.push(verse << "  #{bookno}:#{lectureno}:#{lessonno}:#{verseno}")
    #puts verse
    verse = ''
    next
  end
  #puts "   #{line.strip}" unless not verses
  verse.concat(line.strip << ' ') unless not verses

  #if count > 150 then break end
  #count += 1

end

#puts versearray.join("\n")

require 'yaml'
yaml_arr = versearray.to_yaml
File.open("ak.yaml", "w+") { |file| file.puts yaml_arr }
