require 'drb'

class CalcAgentWrapper

  def initialize(callerObj = Object.new)
    @callerObj = callerObj
    DRb.start_service()
    @bot = DRbObject.new(nil, 'druby://localhost:9190')
  end

  def method_missing(input = '')
    input = input.to_s
    input.chomp!
    if input =~ /^\w+(?:bot|agent)/i and input !~ /^calc/i then return end
    if input =~ /^link\b/i then return end
    if input =~ /^lgp\b/i then return end
    if input =~ /^alice\b/i then return end
    if input =~ /^if\b/i then return end
    if input =~ /^porsi\b/i then return end
    response, score  = @bot.getResponse(input)
    if score == nil then score = 1 end
    if response.to_s =~ /Default response/ then score = 0 end
    if input =~ /^calc(?:bot|agent)?[:, ]*/i then score += 4 end
    if response.to_s.strip == '' or response == nil then score = 0 end
    response = response.to_s.strip
    puts "CalcBot: #{response} | #{score}" unless @callerObj.DEBUG == 0
    @callerObj.addPendingResponse(["#{response}", score, "calcagent"]) unless response == nil or response.size == 0 or response == "I don't know!" or response =~ /threshhold/
    @callerObj.addResponse(["#{response}", score, "calcagent"])
  end
end
