require 'drb'

class FAQAgentWrapper

  def initialize(callerObj = Object.new)
    @callerObj = callerObj
    DRb.start_service()
    @bot = DRbObject.new(nil, 'druby://localhost:9230')
  end

  def method_missing(input = '')
    input = input.to_s
    input.chomp!
    if input =~ /^\w+(?:bot|agent)/i and input !~ /^faq/i then return end
    if input =~ /^!/ then return end
    if input =~ /^link\b/i then return end
    if input =~ /^lgp\b/i then return end
    if input =~ /^alice\b/i then return end
    if input =~ /^if\b/i then return end
    if input =~ /^calc\b/i then return end
    if input =~ /^logic\b/i then return end
    #@callerObj.set_wait_for_agent("faqagent")
    response, score  = @bot.getResponse(input)
    #@callerObj.unset_wait_for_agent("faqagent")
    if score == nil then score = 1 end
    if response.to_s =~ /Default response/ then score = 0 end
    if response.to_s !~ /^I do/ and response.to_s =~ /\?\n/ then score += 2 end 
    if input =~ /^faq(?:bot|agent)?[:, ]*/i then score += 4 end
    if response.to_s.strip == '' or response == nil then score = 0 end
    response = response.to_s.strip
    puts "FAQBot: #{response} | #{score}" unless @callerObj.DEBUG == 0
    @callerObj.addResponse(["#{response}", score, "faqagent"])
  end
end
