require 'drb'

class ISRAgent

  def initialize(callerObj = Object.new)
    @callerObj = callerObj
    DRb.start_service()
    @isragent = DRbObject.new(nil, 'druby://localhost:9080')
  end

  def method_missing(input = '')
    input = input.to_s
    input.chomp!
    if input =~ /^\w+(?:bot|agent)/i and input !~ /^(isr|sr|soviet|!isr|!sr)/ then return end
    if input =~ /^link\b/i then return end
    if input =~ /^lgp\b/i then return end
    if input =~ /^alice\b/i then return end
    if input =~ /^megahal\b/i then return end
    if input =~ /^calc\b/i then return end
    if input =~ /^porsi\b/i then return end
    if input =~ /^what is your name/i 
      @callerObj.addResponse ["isrbot", 1, "isragent"]
      return
    end
    response, score = @isragent.getResponse(input)
    if score == nil then score = 1 end
    if response =~ /Default response/ then score = 0 end
    #if response =~ /YOU/ then score += 1 end
    if input =~ /(?:isragent|isrbot|srbot|soviet russia agent|sragent|sr|!sr|!isr)/i
      score += 3
    end
    if response == nil or response.strip == '' then score -= 2 end
    if response =~ /That never happens in Soviet Russia/i then score -= 1 end
    puts "ISRAgent: #{response} | #{score}" unless @callerObj.DEBUG == 0
    @callerObj.addResponse(["#{response}", score, "isragent"])
  end
end
