require 'test/unit'
require 'isragent'

BasicSocket.do_not_reverse_lookup = true

class TestISRAgent < Test::Unit::TestCase

  def setup
    @agent = MyAgent.new
  end

  def test_1
    actual, s = @agent.send("!sr In California, you can always find a party.")
    assert_match(/the party can always find YOU/, actual)

    actual, s = @agent.send("you attempt to colonize Mars")
    assert_match(/Mars attempt to colonize YOU!/, actual)

    actual, s = @agent.send("Mars is singular")
    assert_match(/Okay/, actual)

    actual, s = @agent.send("you attempt to colonize Mars")
    assert_match(/Mars attempts to colonize YOU!/, actual)
  end	  

end # class
