require 'drb'

class LingAgent

  def initialize(callerObj = Object.new)
    @callerObj = callerObj
    DRb.start_service()
    @lingagent = DRbObject.new(nil, 'druby://localhost:9090')
  end

  def method_missing(input = '')
    input = input.to_s
    input.chomp!
    response, score = @lingagent.getResponse(input)
    #puts "[Lingagent] response=#{response}, score=#{score}"
    if score == nil then score = 1 end
    if input =~ /(?:lingagentbot|lingbot|lingagent|linguisticsagent|linguistics|ling)/i
      score += 3
    end
    if input =~ /^(?:plural|infinitive)/ then score += 3 end
    if response =~ /Default response/ then score = 0 end
    if response == nil or response.strip == '' then score -= 2 end
    puts "LingAgent: #{response} | #{score}" unless @callerObj.DEBUG == 0
    @callerObj.addResponse(["#{response}", score, "lingagent"])
  end
end
