require 'drb'

class MegaHALAgent

  def initialize(callerObj = Object.new)
    @callerObj = callerObj
    DRb.start_service()
    @megahal = DRbObject.new(nil, 'druby://localhost:9060')
  end

  def method_missing(input = "")
    input = input.to_s
    input.chomp!
    if input =~ /^restart (.*)/ then return end 
    if input =~ /^alice\b/ then return end
    if input =~ /^link\b/ then return end
    if input =~ /^what is your name\?/i 
      @callerObj.addResponse ["megahal", 1, "megahal"] 
      return
    end
    response, score = @megahal.getResponse(input.to_s)
    if response.size > 145 then score -= 2 end
    if score == nil then score = 4 end
    if input =~ /megahal/ then score += 2 end
    if response.strip == '' or response == nil then score = 0 end
    puts "MegaHAL: #{response} | #{score}" unless @callerObj.DEBUG == 0
    @callerObj.addResponse([response, score, "megahal"])
  end

end
