require 'drb'

class RestartAgentWrapper

  def initialize(callerObj = Object.new)
    @callerObj = callerObj
    DRb.start_service()
    @bot = DRbObject.new(nil, 'druby://localhost:9150')
  end

  def method_missing(input = '')
    input = input.to_s
    input.chomp!
    if input =~ /^\w+(?:bot|agent)/ and input !~ /^restart/ then return end
    response, score  = @bot.getResponse(input)
    if score == nil then score = 1 end
    if response.to_s =~ /Default response/ then score = 0 end
    if input =~ /^restart(?:bot|agent)?[:, ]*/i then score += 4 end
    if response.to_s.strip == '' or response == nil then score = 0 end
    response = response.to_s.strip
    if response =~ /Okay/ then score += 3 end
    if response =~ /^Killed*/i then score += 3 end
    puts "RestartBot: #{response} | #{score}" unless @callerObj.DEBUG == 0
    @callerObj.addResponse(["#{response}", score, "restartagent"])
  end
end
