require 'drb'

class TodoAgentWrapper

  def initialize(callerObj = Object.new)
    @callerObj = callerObj
    DRb.start_service()
    @bot = DRbObject.new(nil, 'druby://localhost:9170')
  end

  def method_missing(input = '')
    input = input.to_s
    input.chomp!
    if input =~ /^\w+(?:bot|agent)/i and input !~ /^todo/i then return end
    if input =~ /^alice\b/ then return end
    if input =~ /^link\b/ then return end
    if input =~ /^lgp\b/ then return end
    if input =~ /^calc\b/ then return end
    if input =~ /^porsi\b/ then return end
    if input =~ /^ling\b/ then return end
    if input =~ /^logic\b/ then return end
    @callerObj.set_wait_for_agent("todoagent")
    response, score  = @bot.getResponse(input)
    @callerObj.unset_wait_for_agent("todoagent")
    if score == nil then score = 1 end
    if response.to_s =~ /Default response/ then score = 0 end
    if input =~ /^todo(?:bot|agent)?[:, ]*/i then score += 4 end
    if response.to_s.strip == '' or response == nil then score = 0 end
    response = response.to_s.strip
    puts "TodoBot: #{response} | #{score}" unless @callerObj.DEBUG == 0
    @callerObj.addResponse(["#{response}", score, "todoagent"])
  end
end
