require 'drb'

class WNAgent

  def initialize(callerObj = Object.new)
    @callerObj = callerObj
    DRb.start_service()
    @wnbot = DRbObject.new(nil, 'druby://localhost:9040')
  end

  def method_missing(input = '')
    if input =~ /^\w+(bot|agent)\b/i and input !~ /^wn/i then return end
    if input =~ /^alice\b/i then return end
    if input =~ /^link\b/i then return end
    if input =~ /^lgp\b/i then return end
    if input =~ /^calc\b/i then return end
    if input =~ /^porsi\b/i then return end
    if input =~ /^isr\b/i then return end
    if input =~ /^!i*sr\b/i then return end
    if input =~ /^what is your name\?/i 
      @callerObj.addResponse ["wnbot", 1, "wnbot"] 
      return
    end
    input = input.to_s
    input.chomp!
    response, score  = @wnbot.getResponse(input)
    if score == nil then score = 1 end
    if response.to_s =~ /Default response/ then score = 0 end
    if response.to_s =~ /\(/ then score += 1 end
    if input =~ /^wn[(bot|agent)?][:, ]*/i then score += 2 end
    if input =~ /!syns/ then score += 2 end
    if input =~ /syns/ then score += 2 end
    if input =~ /!syns\:/ then score +=2 end
    if input =~ /syns\:/ then score += 2 end
    if response.to_s.strip == '' or response == nil then score = 0 end
    puts "WNBot: #{response} | #{score}" unless @callerObj.DEBUG == 0
    @callerObj.addResponse(["#{response}", score, "wnagent"])
  end
end
